/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("rdm.simulinkintegration.diagram.DiagramStore");

dojo.require("rdm.simulinkintegration.behavior.HotspotDiagramController");
dojo.require("rmpw.dsv.editor.data.EcoreAuthStore");
dojo.require("rmps.graphics.ui.DiagramLoader");
dojo.require("rmps.graphics.render.HotspotDiagramViewMapping");

dojo.require("rmpw.diagrams.edit.tools.DragPan");
dojo.require("rmpw.diagrams.edit.tools.TouchZoom");
dojo.require("rmpw.diagrams.edit.tools.WheelZoom");

(function() {
	
	dojo.declare("rdm.simulinkintegration.diagram.DiagramStore", [ rmpw.dsv.editor.data.EcoreAuthStore ],	{

		fetch: function(resourceInfo, definition) {
			if(!resourceInfo) {
				return;
			}		
			
			this.viewer.clear();
			dojo.mixin(this.viewer, {
				drawDiagram: function(model) {
					var diagram = new rmps.graphics.render.HotspotDiagramViewMapping();
					diagram.setModel(model);
					diagram.setParentFigure(this.viewer.viewport.contents);
					
					this.controller = new rdm.simulinkintegration.behavior.HotspotDiagramController( diagram );		
					var controller = this.controller;
					var viewer = this.viewer;
				
					this.controller._connectConstruction = dojo.connect(diagram, "applyModelChanges", this, function() {			
						controller.setParent(viewer);
						controller.setRenderMapping( diagram );
						dojo.disconnect( controller._connectConstruction );
						delete controller._connectConstruction;
					});			
					this.viewer.setDiagram(diagram);
					
				},
			});
			this.loader = new rmps.graphics.ui.DiagramLoader();	    
			this.loader.handleDiagramAssets( resourceInfo.uri, null, this.viewer );
		},
		
		save: function() {
			// do nothing
		},
		
		deleteResource: function() {
			// do nothing
		}
	
				
	});
})();
